Index: apps/app_directory.c
===================================================================
--- apps/app_directory.c	(revision 46843)
+++ apps/app_directory.c	(working copy)
@@ -77,7 +77,9 @@
 "    e - In addition to the name, also read the extension number to the\n"
 "        caller before presenting dialing options.\n"
 "    f - Allow the caller to enter the first name of a user in the directory\n"
-"        instead of using the last name.\n";
+"        instead of using the last name.\n"
+"    b - Allow the caller to enter the first name OR last name of a user in\n"
+"        the directory.\n";
 
 /* For simplicity, I'm keeping the format compatible with the voicemail config,
    but i'm open to suggestions for isolating it */
@@ -452,6 +454,20 @@
 					if (pos) {
 						ast_copy_string(name, pos, sizeof(name));
 						/* Grab the last name */
+						if (last==2) /* Check the first name before advancing to the last name */
+						{
+							conv = convert(pos);
+							if (conv) {
+								if (!strcmp(conv, ext)) {
+									/* Match! */
+									found++;
+									free(conv);
+									free(start);
+									break;
+								}
+								free(conv);
+							}
+						}
 						if (last && strrchr(pos,' '))
 							pos = strrchr(pos, ' ') + 1;
 						conv = convert(pos);
@@ -593,6 +609,8 @@
 	if (args.options) {
 		if (strchr(args.options, 'f'))
 			last = 0;
+		if (strchr(args.options, 'b'))
+			last = 2;
 		if (strchr(args.options, 'e'))
 			readext = 1;
 		if (strchr(args.options, 'v'))
@@ -615,7 +633,7 @@
 	if (ast_strlen_zero(dirintro))
 		dirintro = ast_variable_retrieve(cfg, "general", "directoryintro");
 	if (ast_strlen_zero(dirintro))
-		dirintro = last ? "dir-intro" : "dir-intro-fn";
+		dirintro = last==2 ? "dir-intro-fnln" : ( last ? "dir-intro" : "dir-intro-fn" );
 
 	if (chan->_state != AST_STATE_UP) 
 		res = ast_answer(chan);
